var days = new Array(
	'sun',
	'mon',
	'tue',
	'wed',
	'thu',
	'fri',
	'sat'
);


/**
 * Increases hour at user's main interface
 */
function toUp(day,id)
{
	
	var fieldName = day+id;
	var field = Ext.get(fieldName);
	if (field.dom.disabled == true)
		return true;
	
	var value = parseInt(field.dom.value);
	
	if (value == 23) {		
		value = 0;
	} else {
		value++;
	}
		
	field.dom.value = value+"h";
	
	/*
	if (id == 1 && value != 0)
		showColumn(day);
	
	if (id == 1 && value == 0)
		hidColumn(day);
	*/
		
	validateDay(day);
	updateHourCount(day,id);
}


/**
 * Decreases hour at user's main interface
 */
function toDown(day,id)
{
	var fieldName = day+id;
	var field = Ext.get(fieldName);
	var value = parseInt(field.dom.value);

	if (field.dom.disabled == true)
		return true;
	
	if (value == 0) {
		value = 23;
	} else {
		value--;
	}
		
	field.dom.value = value+"h";

	/*
	if (id == 1 && value != 0)
		showColumn(day);
	*/
		
	validateDay(day);
	updateHourCount(day);
}


function updateHourCount(day)
{
	
	var f0 = Ext.get(day+"0");
	var f1 = Ext.get(day+"1");
	var f2 = Ext.get(day+"2");
	var f3 = Ext.get(day+"3");
	
	var v0 = parseInt(f0.dom.value);
	var v1 = parseInt(f1.dom.value);
	var v2 = parseInt(f2.dom.value);
	var v3 = parseInt(f3.dom.value);
	
	if (v3 == 0)
		v3 = 24;
	
	if (v1 == 0)
		v1 = 24;
	
	
	var fieldName = day+"_hourcount";
	var outField = Ext.get(fieldName);
		
	var column2 = Ext.get(day+"2ndline");
	var dif;
	if (column2.dom.style.display == 'none' || (v2 == 0 && v3 == 24)) {
		dif =  v1 - v0;
	} else {
		dif = (v3 - v2) + (v1 - v0);
	}
	
	if (dif > 24 || dif <= 0) {
		disableSaveButton();
		dif = "<font color='red'>"+dif+"</font>";
	}
	outField.dom.innerHTML = "Total: "+dif+"h";
	
}


/**
 * Show a new column for second time period
 * selection, receives the day short name as 
 * parameter
 */
function showColumn(id)
{
	
	var columnId = id+"2ndline";
	var fieldId = id+'0';
	
	// if input field was disabled
	var inputField = Ext.get(fieldId);
	if (inputField.dom.disabled)
		return true;
	
	var hiddenfield = Ext.get(columnId);
	if (hiddenfield.dom.style.display != "none")
		return true;
	
	hiddenfield.fadeIn();
	if (Ext.isIE) {
		hiddenfield.dom.style.display = "block";		
	} else {
		hiddenfield.dom.style.display = "table-row";
	}

	var btId = Ext.get(id+"plusbutton");
	btId.dom.style.display = "none";
	
	updateHourCount(id);
}

/**
 * Hide second time cut input fields
 * Receives a short name for the day 
 * as parameter
 */
function hidColumn(id)
{
	var fieldName = id+'2ndline';
	var field = Ext.get(fieldName);
	field.fadeOut({
		useDisplay: true,
		callback: function() {
			field.dom.style.display = 'none';
			updateHourCount(id);
			var btId = Ext.get(id+"plusbutton");
			btId.dom.style.display = "block";
		}
	});
}

/**
 * Enable/Disable a day at user interface
 */
function changeDay(day)
{
	var i = 0;
	var field;
	var fieldName;
	
	
	var checkBox = Ext.get(day+"check").dom;
	
	for(i=0; i<4; i++) {
		fieldName = day+i
		field = Ext.get(fieldName);
		if ( checkBox.checked == true ) {
			field.dom.disabled = false;
		} else {
			field.dom.disabled = true;
		}
	}
}

/**
 * Change image color to simulate on click event
 */
function changeImg(obj)
{
	var path = obj.src;
	var a = new Array();
	
	a = path.split("/");
	
	switch(a[a.length-1]) {
		
	case "up.gif":
		a[a.length-1] = "press_up.gif";
		break;
	
	case "press_up.gif":
		a[a.length-1] = "up.gif";
		break;
		
	case "down.gif":
		a[a.length-1] = "press_down.gif";
		break;
		
	case "press_down.gif":
		a[a.length-1] = "down.gif";
		break;
		
	}
	
	obj.src = implode("/",a);
	
}

/**
 * Return original image "onmouseout" event 
 */
function originalImg(obj)
{
	var path = obj.src;
	var a = new Array();
	
	a = path.split("/");
	
	switch(a[a.length-1]) {

	case "press_up.gif":
		a[a.length-1] = "up.gif";
		break;

	case "press_down.gif":
		a[a.length-1] = "down.gif";
		break;
		
	}

	obj.src = implode("/",a);
}

/**
 * Validate given configuration for a day
 * show a help message
 */
function validateDay(day)
{

	var i;
	var elemI;
	var help = false;
	
	for(i=0; i<4; i++) {
		
		elemI = Ext.get(day+i);
		value = parseInt(elemI.dom.value);
		
		if (i >=1 && value == 0)
			value = 24;
		
		for(j=i+1; j<4; j++) {
			elemJ = Ext.get(day+j);
			value2 = parseInt(elemJ.dom.value);
			if (value2 == 0)
				value2 = 24;
			
			if (value > value2) {
				elemI.dom.style.background = '#e64747';
				help = true;
				j = 4;
			} else {
				elemI.dom.style.background = '#ffffff';
			}
		}
		
	}
	

	if (help) {
		disableSaveButton();
		//showHelp('t&iacute;tulo','teste de acentua&ccedil;&atilde;o');
	} else {
		enableSaveButton();
		//hideHelp();
	}
	
}

/**
 * Add "on click image change" to buttons
 */
function addButtonEvents()
{
	var ar = new Array();
	ar = Ext.query('img');
	
	for(var i=0; i<ar.length; i++) {
		if (/(up|down)/.test(ar[i].src)) {
			ar[i].onmousedown = new Function("changeImg(this);");
			ar[i].onmouseup = new Function("changeImg(this);");
			ar[i].onmouseout = new Function("originalImg(this);");
		}
	}
	
}

/**
 * Create a modal window to ask Timecut Name
 * then pass it to save function after OK
 */
function askName()
{
	
	var btn = Ext.get("savebutton").dom;
	if (/(disabled)/.test(btn.src))
		return true;
		
	var id = Ext.get("timecutId");

	if (id.dom.value == 0) {	
		Ext.MessageBox.buttonText.cancel = langArray[60];
	        box = Ext.MessageBox.prompt(
			langArray[44],
			langArray[59],
			save
	        );
	} else {
		var w = id.dom.selectedIndex;
		var selected_text = id.dom.options[w].text;

		Ext.MessageBox.buttonText.cancel = langArray[60];
	        box = Ext.MessageBox.prompt(
			langArray[44],
			langArray[59],
			save,
			false,
			false,
			selected_text
	        );
	}
}

/**
 * Get values from forms, create an ajax
 * instance and send these values
 */
function save(btn, name)
{

	// the user had clicked 'cancel'
	if (btn != 'ok')
		return false;
	
	name = changeCharCode(name);
	var submitArray = new Array();
	
	// get data from sunday to saturday
	var obj;
	for(var i=0; i<days.length; i++) {
		obj = Ext.get(days[i]+'check');
		submitArray[days[i]] = new Array();
		
		if (!obj.dom.checked) {
			// unchecked day, ignore at server side
			submitArray[days[i]] = "-1#-1#-1#-1";
		} else {
			submitArray[days[i]] = parseInt(Ext.get(days[i]+'0').dom.value)+"#";
			submitArray[days[i]] += parseInt(Ext.get(days[i]+'1').dom.value);
			
			if (Ext.get(days[i]+"2ndline").dom.style.display == 'none') {
				// just one timecut this day
				submitArray[days[i]] += "#-1";
				submitArray[days[i]] += "#-1";
			} else {
				submitArray[days[i]] += "#"+parseInt(Ext.get(days[i]+'2').dom.value);
				submitArray[days[i]] += "#"+parseInt(Ext.get(days[i]+'3').dom.value);
			}
		}
	}
	
	/*for(i=0; i<days.length; i++) {
		alert("["+name+"] Day "+days[i] +
		      " "+submitArray[days[i]][0] +
		      " "+submitArray[days[i]][1] +
		      " "+submitArray[days[i]][2] +
		      " "+submitArray[days[i]][3]    
		);
	}*/
	
	var id = Ext.get("timecutId").dom.value;
	Ext.Ajax.request({
		url: '/opmon/seagull/www/index.php/timecut/action/saveme/?',
		method:	'post',
		params:	{
			id: id,
			timecutName: name,
			sun: submitArray['sun'],
			mon: submitArray['mon'],
			tue: submitArray['tue'],
			wed: submitArray['wed'],
			thu: submitArray['thu'],
			fri: submitArray['fri'],
			sat: submitArray['sat']
		},
		success: function( result, request ) {
			if (result.responseText == 0) {
				Ext.MessageBox.show({
					title: 'OpMon',
					msg: langArray[62],
					fn: function() {
						window.location.reload();
					},
					buttons: Ext.MessageBox.OK,
					icon: Ext.MessageBox.INFO
				});

			} else {
				Ext.MessageBox.show({
					title: 'OpMon',
					msg: langArray[61],
					buttons: Ext.MessageBox.OK,
					icon: Ext.MessageBox.ERROR
				});
			}
		}
	});

}


function enableRemoveButton()
{
	var img = Ext.get("removebutton");
	var tmp = new Array();
	tmp = img.dom.src.split("/");
	tmp[tmp.length-1] = "remove.gif";
	var tmp2 = implode("/",tmp);
	img.dom.src = tmp2;	
}

function disableRemoveButton()
{
	var img = Ext.get("removebutton");
	var tmp = new Array();
	tmp = img.dom.src.split("/");
	tmp[tmp.length-1] = "disabled-remove.gif";
	var tmp2 = implode("/",tmp);
	img.dom.src = tmp2;	
}

function enableSaveButton()
{
	var img = Ext.get("savebutton");
	var tmp = new Array();
	tmp = img.dom.src.split("/");
	tmp[tmp.length-1] = "save.gif";
	var tmp2 = implode("/",tmp);
	img.dom.src = tmp2;	
}

function disableSaveButton()
{
	var img = Ext.get("savebutton");
	var tmp = new Array();
	tmp = img.dom.src.split("/");
	tmp[tmp.length-1] = "disabled-save.gif";
	var tmp2 = implode("/",tmp);
	img.dom.src = tmp2;	
}

function confirmRemove()
{
	var id = Ext.get('timecutId').dom.value;
	if (id <= 0)
		return;

	Ext.MessageBox.buttonText.cancel = langArray[60];
	
	Ext.MessageBox.show({
		title: 'OpMon',
		msg: langArray[64],
		fn: function(btn) {
			removeTimecut(btn);
			return false;
		},
		buttons: Ext.MessageBox.OKCANCEL,
		icon: Ext.MessageBox.QUESTION
	});
}


function removeTimecut(btn)
{
	
	if (btn != 'ok')
		return;
		
	var id = Ext.get('timecutId').dom.value;
		
	Ext.Ajax.request({
		url: '/opmon/seagull/www/index.php/timecut/action/remove/?',
		method:	'post',
		params:	{ 
			id: id
		}
	});
	
	Ext.MessageBox.show({
		title: 'OpMon',
		msg: langArray[65],
		fn: function() {
			window.location.reload();
		},
		buttons: Ext.MessageBox.OK,
		icon: Ext.MessageBox.INFO
	});
	
}



/**
 * Load through ajax a timecut
 */
function loadTimecut() {
	
	var id = Ext.get('timecutId').dom.value;

	if (id <= 0) {
		disableRemoveButton();
		return;
	} else {
		enableRemoveButton();
	}
	
	Ext.Ajax.request({
		url: '/opmon/seagull/www/index.php/timecut/action/load/?',
		method:	'post',
		params:	{ 
			id: id
		},
		success: function( result, request ) {
			
			if (result.responseText == ERR_UNKNOWN) {
				Ext.MessageBox.show({
					title: 'OpMon',
					msg: langArray[63],
					fn: function() {
						window.location.reload();
						return false;
					},
					buttons: Ext.MessageBox.OK,
					icon: Ext.MessageBox.ERROR
				});
				return;
			}
			
			var lines = result.responseText.split("\n");
			
			for(var i=0; i<days.length; i++) {

				var fieldName = days[i]+"check";
				var obj = Ext.get(fieldName);
				var v = getArrayValue(lines,fieldName);
				if (v == 1) {
					obj.dom.checked = true;
				} else {
					obj.dom.checked = false;
				}
				changeDay(days[i]);

				for(var j=0; j<4; j++) {
					fieldName = days[i]+j;
					v = getArrayValue(lines,fieldName);
										
					if (j == 3) {
						(v == -1) ? hidColumn(days[i]) : showColumn(days[i]);
					}
										
					if (v == -1)
						v = 0;
						
					obj = Ext.get(fieldName);
					obj.dom.value = v+"h";			
				}

				updateHourCount(days[i]);
				for(j=0; j<days.length; j++) {
					validateDay(days[j]);
				}
			}
		}
	});
}


function getArrayValue(lines, str)
{
	for(var i=0; i<lines.length; i++) {
		
		var col = new Array();
		col = lines[i].split("=");

		if (col[0] != str)
			continue;
			
		var aTmp = new Array();
		return col[1];
	}
}